{% extends '_base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block css %}

<link href="https://vjs.zencdn.net/8.3.0/video-js.css" rel="stylesheet" />

<!-- If you'd like to support IE8 (for Video.js versions prior to v7) -->
<!-- <script src="https://vjs.zencdn.net/ie8/1.1.2/videojs-ie8.min.js"></script> -->

{% endblock css %}

{% block title %}- {{media.name}} {% endblock title %}

{% block breadcrumb %}
<nav aria-label="breadcrumb">
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><a href="{% url 'dashboard' %}">Dashboard</a></li>
    <li class="breadcrumb-item"><a href="{% url 'project_details' project_id=project.uuid%}">Project</a></li>
    <li class="breadcrumb-item"><a href="{% url 'collection_details' project_id=project.uuid collection_id=collection.uuid %}">Collection</a></li>
    <li class="breadcrumb-item active" aria-current="page">Media</li>
  </ol>
</nav>
{% endblock breadcrumb %}

{% block content %}

  <div class="accordion" id="accordionExample">
    <div class="accordion-item">
      <h2 class="accordion-header">
        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
          {{media.name}}
        </button>
      </h2>
      <div id="collapseOne" class="accordion-collapse collapse show" data-bs-parent="#accordionExample">
        <div class="accordion-body">
          <p> {{collection.description}} </p>
          <p> file size : {{media.media.orig_size|filesizeformat}} </p>
          <p>Created By: {{media.created_by}} </p>
          <p> Uploaded: {{media.created_at|timesince}} ago</p>
        </div>
      </div>
    </div>
  </div>

  <br/>
  <div class="row">
    <div class="col-6">
      <video
        id="my-video"
        class="video-js"
        controls
        preload="auto"
        width="640"
        height="264"
        data-setup="{}"
        >
        <source src="{{media.media.media.url}}" type="{{media.media.file_extension}}" />
        <p class="vjs-no-js">
          To view this video please enable JavaScript, and consider upgrading to a
          web browser that
          <a href="https://videojs.com/html5-video-support/" target="_blank"
            >supports HTML5 video</a
          >
        </p>
      </video>
      <br />
      <div class="row">
        <div class="col-lg-3 col-md-3"></div>
        <div class="btn-group col-lg-6 col-md-6 col-sm-12" role="group" aria-label="Basic mixed styles example">
          <button class="btn btn-primary" id="play_pause_video"> Play </button>
          <button class="btn btn-primary" id="start_time_tracker"> Start </button>
          <button class="btn btn-primary" id="end_time_tracker"> End </button>
        </div>
        <div class="col-lg-3 col-md-3"></div>
      </div>
      <hr />
      {% comment %} <form action="{% url 'create_annotation' project_id=project.uuid collection_id=collection.uuid media_mapper_id=media.uuid %}" method="POST" class="form"> {% endcomment %}
        <form>
          <div id="parent-div"> 
            {% include "projects/_includes/annotation_form.html"%}
            {% comment %} Hack because the htmx outerhtml swap reset the select2 option {% endcomment %}
            <div class="col-12">
              <select class="form-control" id="tag_selector" name="tags">
                {% for tag in tags %}
                  <option>{{tag.name}}</option>
                {% endfor %}
              </select>
            </div>
        <button hx-post="{% url 'create_annotation' project_id=project.uuid collection_id=collection.uuid media_mapper_id=media.uuid %}" hx-trigger="click" hx-target="#parent-div" hx-swap="innerHTML" class="btn btn-primary"> Annotate </button>
      </form>
      <div id="annotation_form_response"></div>
    </div>

    <div class="col-6 list_annotations" hx-get="{% url "list_annotations"  project_id=project.uuid collection_id=collection.uuid media_mapper_id=media.uuid%}" hx-trigger="newAnnotationAdded from:body">
      {% include "projects/_includes/annotation_list.html" %}
    </div>
  </div>

{% endblock content %}

{% block javascript %}
    <script src="https://unpkg.com/htmx.org@1.9.2"></script>
    <script src="https://vjs.zencdn.net/8.3.0/video.min.js"></script>
    <script>
      var player = videojs('my-video', {
        controlBar: {
          skipButtons: {
            forward: 3
          }
        }
      });
      document.getElementById("start_time_tracker").onclick = function(){
        curTime = player.currentTime()
        document.getElementById("start_time").value = parseInt(curTime)
      }
      document.getElementById("end_time_tracker").onclick = function(){
        curTime = player.currentTime()
        document.getElementById("end_time").value = parseInt(curTime)
        document.getElementById("play_pause_video").innerText = "Play"
        player.pause()
      }
      /* Pause and Play button actions */
      document.getElementById("play_pause_video").onclick = function(){
        if(player.paused()){
          document.getElementById("play_pause_video").innerText = "Pause"
          player.play()
        }else{
          document.getElementById("play_pause_video").innerText = "Play"
          player.pause()
        }
      }
      
      function playFragment(media_target) {
        player.currentTime(media_target.split(",")[0])
        player.play()
    }

      {% comment %} input.addEventListener("change", updateValue); {% endcomment %}

    </script>

{% endblock javascript %}